#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

int fd_val[4];
char s[64];

void init_gpio()
{
	int fd_exp, fd_dir;
	int i;
	fd_exp = open("/sys/class/gpio/export", O_WRONLY);
	if (fd_exp < 0) {
	printf("GPIO export open error\n");
	exit(1);
	}

	write(fd_exp, "7", 2);
	write(fd_exp, "8", 2);
	write(fd_exp, "9", 2);
	write(fd_exp, "10", 3);
	close(fd_exp);

	for (i=7; i<=10; i++) {
		sprintf(s,"/sys/class/gpio/gpio%d/direction",i);
		fd_dir = open(s, O_RDWR);
		if (fd_dir < 0) {
			printf("GPIO %d direction open error\n",i);
			exit(1);
		}
		write(fd_dir, "out", 4);
		close(fd_dir);
	}

}

void release_gpio()
{
	int fd_exp;

	fd_exp = open("/sys/class/gpio/unexport", O_WRONLY);
	if (fd_exp < 0) {
		printf("GPIO unexport open error\n");
		exit(1);
	}
	write(fd_exp, "7", 2);
	write(fd_exp, "8", 2);
	write(fd_exp, "9", 2);
	write(fd_exp, "10", 2);
	close(fd_exp);
}


gpio_open()
{
	int i;
	for (i=0; i<4; i++) {
	sprintf(s,"/sys/class/gpio/gpio%d/value",i+7);
		fd_val[i] = open(s, O_RDWR);
		if (fd_val[i] < 0) {
			printf("GPIO %d value open error\n",i);
			exit(1);
		}
	}

}

gpio_close()
{
	int i;
	for (i=0; i<4; i++) {
		close(fd_val[i]);
	}

}

int main(int argc, char *argv[])
{
	int i,j;
	unsigned int dat;

	if (argc == 2) {
		gpio_open();
		sscanf(argv[1],"%x",&dat);
		printf("%x\n",dat);
		if (dat < 0x10) {
			for (j=0; j<4; j++) {
				if (dat & (1 << j))
					write(fd_val[j],"1",2);
				else	write(fd_val[j],"0",2);
			}
			gpio_close();
		} else {
			release_gpio();
		}
	} else {
		init_gpio();
	}
}
